CASUALTY = {}
CASUALTY.Timeout = nil
CASUALTY.DeathCount = nil
CASUALTY.Delay = 1
CASUALTY.SpeechDelay = 2

function CASUALTY.OnLoad()
   this:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH")
end

CASUALTY.EventHandlers = {
   ["CHAT_MSG_COMBAT_FRIENDLY_DEATH"] = function ()
					   -- if we're not in the interval after a seen death,
					   -- start a timer
					   if CASUALTY.Timeout then
					      CASUALTY.DeathCount = CASUALTY.DeathCount + 1
					   else
					      CASUALTY.Timeout = GetTime() + CASUALTY.Delay
					      CASUALTY.DeathCount = 1
					   end
					end
}

function CASUALTY.OnEvent(event)
   func = CASUALTY.EventHandlers[event]
   if func then
      func()
   end
end

function CASUALTY.OnUpdate()
   if CASUALTY.Timeout then
      if CASUALTY.Timeout < GetTime() then
	 -- we've timed out since seeing a death; time to report our message
	 if CASUALTY.DeathCount == 1 then
	    CASUALTY.ReportCasualty()
	 elseif CASUALTY.DeathCount > 1 then
	    CASUALTY.ReportCasualties()
	 else
	    CASUALTY.Timeout = nil
	 end
      end
   end
end

function CASUALTY.ReportCasualty()
   DEFAULT_CHAT_FRAME:AddMessage("Casualty.")
   PlaySoundFile("Interface\\Addons\\Casualty\\Sounds\\casualty.wav")
   CASUALTY.Timeout = GetTime() + CASUALTY.SpeechDelay
   CASUALTY.DeathCount = 0
end

function CASUALTY.ReportCasualties()
   DEFAULT_CHAT_FRAME:AddMessage("Casualties.")
   PlaySoundFile("Interface\\Addons\\Casualty\\Sounds\\casualties.wav")
   CASUALTY.Timeout = GetTime() + CASUALTY.SpeechDelay
   CASUALTY.DeathCount = 0
end
